javax.websocket

## Interface WebSocketContainer

- All Known Subinterfaces:
    ServerContainer

      public interface WebSocketContainer

  A WebSocketContainer is an implementation provided object that provides applications a view on the container running it. The WebSocketContainer container various configuration parameters that control default session and buffer properties of the endpoints it contains. It also allows the developer to deploy websocket client endpoints by initiating a web socket handshake from the provided endpoint to a supplied URI where the peer endpoint is presumed to reside.

  A WebSocketContainer may be accessed by concurrent threads, so implementations must ensure the integrity of its mutable attributes in such circumstances.

  Author:
    dannycoward

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Session` | `connectToServer(Class<?> annotatedEndpointClass, URI path)` Connect the supplied annotated endpoint to its server.
    `Session` | `connectToServer(Class<? extends Endpoint> endpointClass, ClientEndpointConfig cec, URI path)` Connect the supplied programmatic endpoint to its server with the given configuration.
    `Session` | `connectToServer(Endpoint endpointInstance, ClientEndpointConfig cec, URI path)` Connect the supplied programmatic client endpoint instance to its server with the given configuration.
    `Session` | `connectToServer(Object annotatedEndpointInstance, URI path)` Connect the supplied annotated endpoint instance to its server.
    `long` | `getDefaultAsyncSendTimeout()` Return the number of milliseconds the implementation will timeout attempting to send a websocket message for all RemoteEndpoints associated with this container.
    `int` | `getDefaultMaxBinaryMessageBufferSize()` Returns the default maximum size of incoming binary message that this container will buffer.
    `long` | `getDefaultMaxSessionIdleTimeout()` Return the default time in milliseconds after which any web socket sessions in this container will be closed if it has been inactive.
    `int` | `getDefaultMaxTextMessageBufferSize()` Returns the default maximum size of incoming text message that this container will buffer.
    `Set<Extension>` | `getInstalledExtensions()` Return the set of Extensions installed in the container.
    `void` | `setAsyncSendTimeout(long timeoutmillis)` Sets the number of milliseconds the implementation will timeout attempting to send a websocket message for all RemoteEndpoints associated with this container.
    `void` | `setDefaultMaxBinaryMessageBufferSize(int max)` Sets the default maximum size of incoming binary message that this container will buffer.
    `void` | `setDefaultMaxSessionIdleTimeout(long timeout)` Sets the default time in milliseconds after which any web socket sessions in this container will be closed if it has been inactive.
    `void` | `setDefaultMaxTextMessageBufferSize(int max)` Sets the maximum size of incoming text message that this container will buffer.

- - ### Method Detail

    - #### getDefaultAsyncSendTimeout

          long getDefaultAsyncSendTimeout()

      Return the number of milliseconds the implementation will timeout attempting to send a websocket message for all RemoteEndpoints associated with this container. A non-positive number indicates the implementation will not timeout attempting to send a websocket message asynchronously. Note this default may be overridden in each RemoteEndpoint.
      Returns:
        the timeout time in millsenconds.

    - #### setAsyncSendTimeout

          void setAsyncSendTimeout(long timeoutmillis)

      Sets the number of milliseconds the implementation will timeout attempting to send a websocket message for all RemoteEndpoints associated with this container. A non-positive number indicates the implementation will not timeout attempting to send a websocket message asynchronously. Note this default may be overridden in each RemoteEndpoint.

    - #### connectToServer

          Session connectToServer(Object annotatedEndpointInstance,
                                URI path)
                                  throws DeploymentException,
                                         IOException

      Connect the supplied annotated endpoint instance to its server. The supplied object must be a class decorated with the class level `ServerEndpoint` annotation. This method blocks until the connection is established, or throws an error if either the connection could not be made or there was a problem with the supplied endpoint class. If the developer uses this method to deploy the client endpoint, services like dependency injection that are supported, for example, when the implementation is part of the Java EE platform may not be available. If the client endpoint uses dependency injection, use `connectToServer(java.lang.Class, java.net.URI)` instead.
      Parameters:
        `annotatedEndpointInstance` - the annotated websocket client endpoint instance.
        `path` - the complete path to the server endpoint.
      Returns:
        the Session created if the connection is successful.
      Throws:
        `DeploymentException` - if the annotated endpoint instance is not valid.
        `IOException` - if there was a network or protocol problem that prevented the client endpoint being connected to its server.
        `IllegalStateException` - if called during the deployment phase of the containing application.

    - #### connectToServer

          Session connectToServer(Class<?> annotatedEndpointClass,
                                URI path)
                                  throws DeploymentException,
                                         IOException

      Connect the supplied annotated endpoint to its server. The supplied object must be a class decorated with the class level `ServerEndpoint` annotation. This method blocks until the connection is established, or throws an error if either the connection could not be made or there was a problem with the supplied endpoint class.
      Parameters:
        `annotatedEndpointClass` - the annotated websocket client endpoint.
        `path` - the complete path to the server endpoint.
      Returns:
        the Session created if the connection is successful.
      Throws:
        `DeploymentException` - if the class is not a valid annotated endpoint class.
        `IOException` - if there was a network or protocol problem that prevented the client endpoint being connected to its server.
        `IllegalStateException` - if called during the deployment phase of the containing application.

    - #### connectToServer

          Session connectToServer(Endpoint endpointInstance,
                                ClientEndpointConfig cec,
                                URI path)
                                  throws DeploymentException,
                                         IOException

      Connect the supplied programmatic client endpoint instance to its server with the given configuration. This method blocks until the connection is established, or throws an error if the connection could not be made. If the developer uses this method to deploy the client endpoint, services like dependency injection that are supported, for example, when the implementation is part of the Java EE platform may not be available. If the client endpoint uses dependency injection, use `connectToServer(java.lang.Class, javax.websocket.ClientEndpointConfig, java.net.URI)` instead.
      Parameters:
        `endpointInstance` - the programmatic client endpoint instance `Endpoint`.
        `path` - the complete path to the server endpoint.
        `cec` - the configuration used to configure the programmatic endpoint.
      Returns:
        the Session created if the connection is successful.
      Throws:
        `DeploymentException` - if the configuration is not valid
        `IOException` - if there was a network or protocol problem that prevented the client endpoint being connected to its server
        `IllegalStateException` - if called during the deployment phase of the containing application.

    - #### connectToServer

          Session connectToServer(Class<? extends Endpoint> endpointClass,
                                ClientEndpointConfig cec,
                                URI path)
                                  throws DeploymentException,
                                         IOException

      Connect the supplied programmatic endpoint to its server with the given configuration. This method blocks until the connection is established, or throws an error if the connection could not be made.
      Parameters:
        `endpointClass` - the programmatic client endpoint class `Endpoint`.
        `path` - the complete path to the server endpoint.
        `cec` - the configuration used to configure the programmatic endpoint.
      Returns:
        the Session created if the connection is successful.
      Throws:
        `DeploymentException` - if the configuration is not valid
        `IOException` - if there was a network or protocol problem that prevented the client endpoint being connected to its server
        `IllegalStateException` - if called during the deployment phase of the containing application.

    - #### getDefaultMaxSessionIdleTimeout

          long getDefaultMaxSessionIdleTimeout()

      Return the default time in milliseconds after which any web socket sessions in this container will be closed if it has been inactive. A value that is 0 or negative indicates the sessions will never timeout due to inactivity. The value may be overridden on a per session basis using `Session.setMaxIdleTimeout(long)`
      Returns:
        the default number of milliseconds after which an idle session in this container will be closed

    - #### setDefaultMaxSessionIdleTimeout

          void setDefaultMaxSessionIdleTimeout(long timeout)

      Sets the default time in milliseconds after which any web socket sessions in this container will be closed if it has been inactive. A value that is 0 or negative indicates the sessions will never timeout due to inactivity. The value may be overridden on a per session basis using `Session.setMaxIdleTimeout(long)`
      Parameters:
        `timeout` - the maximum time in milliseconds.

    - #### getDefaultMaxBinaryMessageBufferSize

          int getDefaultMaxBinaryMessageBufferSize()

      Returns the default maximum size of incoming binary message that this container will buffer. This default may be overridden on a per session basis using `Session.setMaxBinaryMessageBufferSize(int)`
      Returns:
        the maximum size of incoming binary message in number of bytes.

    - #### setDefaultMaxBinaryMessageBufferSize

          void setDefaultMaxBinaryMessageBufferSize(int max)

      Sets the default maximum size of incoming binary message that this container will buffer.
      Parameters:
        `max` - the maximum size of binary message in number of bytes.

    - #### getDefaultMaxTextMessageBufferSize

          int getDefaultMaxTextMessageBufferSize()

      Returns the default maximum size of incoming text message that this container will buffer. This default may be overridden on a per session basis using `Session.setMaxTextMessageBufferSize(int)`
      Returns:
        the maximum size of incoming text message in number of bytes.

    - #### setDefaultMaxTextMessageBufferSize

          void setDefaultMaxTextMessageBufferSize(int max)

      Sets the maximum size of incoming text message that this container will buffer.
      Parameters:
        `max` - the maximum size of text message in number of bytes.

    - #### getInstalledExtensions

          Set<Extension> getInstalledExtensions()

      Return the set of Extensions installed in the container.
      Returns:
        the set of extensions.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.